#--
#
# Author:
#   Sebastian Tello
#
# Copyright (c) 2003,2012 CORE Security Technologies, CORE SDI Inc.
# All rights reserved.
#
# This computer software is owned by Core SDI Inc. and is
# protected by U.S. copyright laws and other laws and by international
# treaties.  This computer software is furnished by CORE SDI Inc.
# pursuant to a written license agreement and may be used, copied,
# transmitted, and stored only in accordance with the terms of such
# license and with the inclusion of the above copyright notice.  This
# computer software or any other copies thereof may not be provided or
# otherwise made available to any other person.
#
#
# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED. IN NO EVENT SHALL CORE SDI Inc. BE LIABLE
# FOR ANY DIRECT,  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY OR
# CONSEQUENTIAL  DAMAGES RESULTING FROM THE USE OR MISUSE OF
# THIS SOFTWARE
#
#--
import sys
#This line makes COM work well with multithreading
sys.coinit_flags = 0
import comtypes.client

from impact_configuration_manager import ImpactConfigurationManager

#GENERATE THE COM GEN CACHE IF IT HASN'T BEEN GENERATED YET

try:
    from comtypes.gen import impact_core_comLib as impact_core_com
except:
    com_exe = ImpactConfigurationManager.get_impact_bin_path() + \
                                                      "/impact_core_com_exe.exe"
    comtypes.client.GetModule(com_exe)
    from comtypes.gen import impact_core_comLib as impact_core_com

#import the rest of the modules as shortcuts
from entities.module import Module
from entity_manager import EntityManager
from impact_com_manager import ImpactComManager
from impact_db_manager import ImpactDBManager
from workspace_manager import WorkspaceManager
from module_manager import ModuleManager
from entities.workspace import Workspace
from entities.entity import Entity
from entities.agent import Agent
from entities.scheduled_task import ScheduledTask
from resources.genlic import GenLic

def set_debug_mode():
    """sets some keys in the registry for module output to be more verbose"""
    ImpactConfigurationManager.ModulesConfiguration.set_module_execution(
                                     auto_select_new_tasks=None,
                                     allow_dropping_on_unsupported_targets=None,
                                     show_system_modules=None,
                                     debugging_mode=1,
                                     attach_debugger=0,
                                     max_concurrency=None)
    ImpactConfigurationManager.ModulesConfiguration.set_module_log(
                                                          detail_level='high',
                                                          add_current_time=None)
    ImpactConfigurationManager.set_quality_report(enabled=True, dumptype=2)

set_debug_mode()